$(function () {
    var $statusFilter = $('#statusFilter');
    
    $('.RequestTitle').click(function (e) {
        var currentID = e.target.id;
        var descriptionID = currentID.replace('requestTitle', '#requestContent');
        $(descriptionID).slideToggle(300);
    });

    var changeFilter = e => location.href = "?filter=" + $(e.target).val();
    $statusFilter.change(changeFilter);
    
    $('.RequestStatus').change(function (e) {
        var requestId = e.target.id.replace('requestStatus', '');
        var status = $(this).val();
        var filter = $statusFilter.val();
        var $statusSelect = $(this);
        var $issue = $("#requestIssue".concat(requestId));

        $statusSelect.turnOff();

        $.postJSON(URLdir + 'handler/RequestsProcessing/setStatus', {
            requestID: requestId,
            status:    status
        }).always(_ => $statusSelect.turnOn())
            .done(res => {
                if (res.success === true)
                    Popup.success('Статус изменён!');
                else
                    Popup.error('Ошибка!');
            });

        var isSatisfyFilter = filter == 'all' || status == filter;
        $issue.attr('style', isSatisfyFilter ? '' : 'border: 3px solid #B70400');
    });

    $('.RefreshButton').click(function () {
        $(this).attr('class', 'fa fa-refresh fa-spin fa-md RefreshButton');
        changeFilter();
    });
});
